// $RCSfile: MS-FCCMN.JS $ $Revision: 1.18 $

function fcChassisName(idx)
{
   var i = parseInt(idx) + 1;
   var rc = "Xg[W VXe ";
   rc += cpqSsChassisEntry[idx].cpqSsChassisName + " (" + i + ")";
   return rc;
}
function fcSwitchName(idx)
{
   var rc = cpqFcSwitchEntry[idx].cpqFcSwitchName;

   if (rc == "")
   {
      rc = "XCb` ";
      if (cpqFcSwitchEntry[idx].cpqFcSwitchChassisSlot < 255)
      {
         rc += cpqFcSwitchEntry[idx].cpqFcSwitchChassisSlot;
      } else {
         rc += cpqFcSwitchEntry[idx].cpqFcSwitchIndex;
      }
   }
   return rc;
}
function boxIoSlot(idx, hbaIdx)
{
   var i;
   var slot = "N/A";

   for (i = 0; i < cpqSsFibreAttachmentEntry.length; i++)
   {
      if (cpqSsFibreAttachmentEntry[i].cpqSsFibreAttachmentDeviceType == 2 &&
          cpqSsFibreAttachmentEntry[i].cpqSsFibreAttachmentHostControllerIndex == hbaIdx &&
          cpqSsFibreAttachmentEntry[i].cpqSsFibreAttachmentDeviceIndex ==
          cpqSsChassisEntry[idx].cpqSsChassisIndex)
      {
         slot = cpqSsFibreAttachmentEntry[i].cpqSsFibreAttachmentDevicePort;
         break;
      }
   }
   return slot;
}
function fcBackplaneName(idx)
{
   var rc = displayItem("cpqSsBackplanePlacement", cpqSsBackplaneEntry[idx].cpqSsBackplanePlacement);
   rc += " Xg[WVXe (" + cpqSsBackplaneEntry[idx].cpqSsBackplaneIndex + ")";
   return rc;
}
function fcCntlrName(idx)
{
   var rc;
   rc = displayItem("cpqFcaCntlrModel", cpqFcaCntlrEntry[idx].cpqFcaCntlrModel)
       + " - Xbg" + cpqFcaCntlrEntry[idx].cpqFcaCntlrBoxIoSlot;
   return rc;
}
function fcPhyDrvName(idx)
{
   var i;
   var drive = cpqFcaPhyDrvEntry[idx];
   var size = parseInt(drive.cpqFcaPhyDrvSize, 10);
   var rc = "|[g" + drive.cpqFcaPhyDrvBusNumber + " hCu" + drive.cpqFcaPhyDrvBay;
   
   if (!isNaN(size) && size > 0)
   {
      rc += "  " + drive.cpqFcaPhyDrvSize + " MB";
   }
   for (i = 0; i < cpqFcaSpareEntry.length; i++)
   {
      if (cpqFcaSpareEntry[i].cpqFcaSpareBoxIndex == drive.cpqFcaPhyDrvBoxIndex &&
          cpqFcaSpareEntry[i].cpqFcaSparePhyDrvIndex == drive.cpqFcaPhyDrvIndex)
      {
         rc += " - XyA";
      }
   }
   return rc;
}
function fcLogDrvName(idx)
{
   var drive = cpqFcaLogDrvEntry[idx];
   var name = "_hCu " + drive.cpqFcaLogDrvIndex;

   if (drive.cpqFcaLogDrvFaultTol == 2)
   {
      name += " - tH[gggȂ";
   }
   else if (drive.cpqFcaLogDrvFaultTol > 2)
   {
      name += " - " + displayItem("cpqFcaLogDrvFaultTol", drive.cpqFcaLogDrvFaultTol);
   }
   return name;
}
function compileFcCondition()
{
   this.state = 1;  // reset to unknown
   this.update(cpqSsChassisEntry[this.index].cpqSsChassisOverallCondition);
}
// RA-8000
function compileSsRaidCondition()
{
   this.state = 1;
   this.update(cpqSsRaidSystemEntry[this.index].cpqSsRaidSystemCondition);
}
function compileFcTapeCondition()
{
   this.state = 1;
   this.update(cpqFcTapeCntlrEntry[this.index].cpqFcTapeCntlrOverallCondition);
}
function fcTapeCntlrName(tapeCntlrIdx)
{
   var rc;
   rc = displayItem("cpqFcTapeCntlrType", cpqFcTapeCntlrEntry[tapeCntlrIdx].cpqFcTapeCntlrType);
   rc +=" (";
   rc += cpqFcTapeCntlrEntry[tapeCntlrIdx].cpqFcTapeCntlrWWN;
   rc +=")";
   return rc;
}
function fcTapeLibraryName(idx)
{
   var rc = cpqFcTapeLibraryEntry[idx].cpqFcTapeLibraryModel +
        " - |[g" + cpqFcTapeLibraryEntry[idx].cpqFcTapeLibraryScsiBus +
        " foCX " + cpqFcTapeLibraryEntry[idx].cpqFcTapeLibraryScsiTarget;
   return rc;
}
function fcTapeDriveIndex(cntlr, bus, id)
{
   for (idx = 0; idx < cpqFcTapeDriveEntry.length; idx++)
   {
      if (cpqFcTapeDriveEntry[idx].cpqFcTapeDriveCntlrIndex == cntlr &&
          cpqFcTapeDriveEntry[idx].cpqFcTapeDriveScsiBus == bus &&
          cpqFcTapeDriveEntry[idx].cpqFcTapeDriveScsiTarget == id)
         break;
   }
   return idx;
}
function fcTapeDriveName(drive)
{
   var rc = "";
   if (drive < cpqFcTapeDriveEntry.length)
   {
      rc  = cpqFcTapeDriveEntry[drive].cpqFcTapeDriveModel +
               " - |[g" + cpqFcTapeDriveEntry[drive].cpqFcTapeDriveScsiBus +
               " foCX " + cpqFcTapeDriveEntry[drive].cpqFcTapeDriveScsiTarget;

      for (cntlr = 0; cntlr < cpqFcTapeCntlrEntry.length; cntlr++)
      {
         if (cpqFcTapeCntlrEntry[cntlr].cpqFcTapeCntlrIndex ==
             cpqFcTapeDriveEntry[drive].cpqFcTapeDriveCntlrIndex)
         {
            rc += " (" + cpqFcTapeCntlrEntry[cntlr].cpqFcTapeCntlrWWN + ")";
            break;
         }
      }
   }
   return rc;
}
function fcDriveCapacity(item, size)
{
   var rc = parseInt(size, 10);
   
   if (isNaN(rc) || rc <= 0)
   {
      rc = "N/A";
   } else {
      rc = displayItem(item, size);
   }
   return rc;
}
